
#include "ppc.h"

#include "m33.h"

PPC::PPC(float hfov, int _w, int _h) {

	w = _w;
	h = _h;
	C = V3(0.0f, 0.0f, 0.0f);
	a = V3(1.0f, 0.0f, 0.0f);
	b = V3(0.0f, -1.0f, 0.0f);
	float hfovr = hfov / 180.0f * 3.1415926f;
	float f = (float)w / (2.0f * tanf(hfovr/2.0f));
	c = V3(-(float)w/2.0f, (float)h/2.0f, -f);

}

int PPC::Project(V3 P, V3& Q) {

	M33 cam; 
	cam.SetColumn(0, a);
	cam.SetColumn(1, b);
	cam.SetColumn(2, c);
	M33 cami = cam.Inverted();
	Q = cami*(P - C);
	if (Q[2] < 0.0f)
		return 0;
	Q[0] = Q[0] / Q[2];
	Q[1] = Q[1] / Q[2];
	return 1;
}

void PPC::Translate(V3 tv) {

	C = C + tv;

}
